=== PLUGINS/src/menuorg-git-12072008/debian/control ===
Source: vdr-plugin-menuorg
Section: misc
Priority: extra
Maintainer: Tobias Grimm <tg@e-tobi.net>
Build-Depends: debhelper (>= 5), cdbs, vdr-dev (>= 1.5.18), pkg-config, gettext, libxml++2.6-dev, libglibmm-2.4-dev
Standards-Version: 3.7.2

Package: vdr-plugin-menuorg
Architecture: any
Depends: ${shlibs:Depends}, ${vdr:Depends}
Conflicts: vdr-plugin-submenu (<< 0.0.2-35)
Replaces: vdr-plugin-submenu (<< 0.0.2-35)
Description: A VDR plug-in to reorganize the OSD main menu
 This plug-in for the Linux Video Disc Recorder VDR allows the main menu in
 VDR's On Screen Display to be reorganized. The order of the displayed menu
 items can be changed and sub menus can be created. Besides this additional
 "command" menu items can be added, which will execute any system commands.
XB-VDR-Patchlevel: ${vdr:Patchlevel}
